{
  IFUDF for InterBase/FireBird

  Author...: Daniel Pereira Guimares
  E-mail...: tecnobyte@ulbrajp.com.br
  Home-page: www.ulbrajp.com.br/~tecnobyte

  This library is Open-Source!
}

library ifudf;

type

  TIBTime = packed record
    Date: integer;
    Time: Cardinal;
  end;

  PIBTime = ^TIBTime;

function TimeToSec(T: TIBTime): int64;
begin
  { Convert TIBTime to seconds }
  Result := int64(T.Date) * 86400 + int64(T.Time) div 10000;
end;

function CompStr(const A, Op, B: string): boolean;
begin
  Result :=
    ((Op = '=') and (A = B)) or
    ((Op = '<>') and (A <> B)) or
    ((Op = '<') and (A < B)) or
    ((Op = '>') and (A > B)) or
    ((Op = '<=') and (A <= B)) or
    ((Op = '>=') and (A >= B)) or
    ((Op = '$') and (Pos(A, B) > 0));
end;

function CompDouble(const A: double; const Op: string; const B: double): boolean;
begin
  Result :=
    ((Op = '=') and (A = B)) or
    ((Op = '<>') and (A <> B)) or
    ((Op = '<') and (A < B)) or
    ((Op = '>') and (A > B)) or
    ((Op = '<=') and (A <= B)) or
    ((Op = '>=') and (A >= B));
end;

function CompInt64(const A: int64; const Op: string; const B: int64): boolean;
begin
  Result :=
    ((Op = '=') and (A = B)) or
    ((Op = '<>') and (A <> B)) or
    ((Op = '<') and (A < B)) or
    ((Op = '>') and (A > B)) or
    ((Op = '<=') and (A <= B)) or
    ((Op = '>=') and (A >= B));
end;

function IF_SS(A, Op, B, C, D: PChar): PChar; cdecl; export;
begin
  if CompStr(A, Op, B) then
    Result := C
  else
    Result := D;
end;

function IF_SN(A, Op, B: PChar; var C, D: double): double; cdecl; export;
begin
  if CompStr(A, Op, B) then
    Result := C
  else
    Result := D;
end;

function IF_ST(A, Op, B: PChar; C, D: PIBTime): PIBTime; cdecl; export;
begin
  if CompStr(A, Op, B) then
    Result := C
  else
    Result := D;
end;

function IF_NS(var A: double; Op: PChar; var B: double; C, D: PChar): PChar; cdecl; export;
begin
  if CompDouble(A, Op, B) then
    Result := C
  else
    Result := D;
end;

function IF_NN(var A: double; Op: PChar; var B, C, D: double): double; cdecl; export;
begin
  if CompDouble(A, Op, B) then
    Result := C
  else
    Result := D;
end;

function IF_NT(var A: double; Op: PChar; var B: double; C, D: PIBTime): PIBTime; cdecl; export;
begin
  if CompDouble(A, Op, B) then
    Result := C
  else
    Result := D;
end;

function IF_TS(A: PIBTime; Op: PChar; B: PIBTime; C, D: PChar): PChar; cdecl; export;
begin
  if CompInt64(TimeToSec(A^), Op, TimeToSec(B^)) then
    Result := C
  else
    Result := D;
end;

function IF_TN(A: PIBTime; Op: PChar; B: PIBTime; var C, D: double): double; cdecl; export;
begin
  if CompInt64(TimeToSec(A^), Op, TimeToSec(B^)) then
    Result := C
  else
    Result := D;
end;

function IF_TT(A: PIBTime; Op: PChar; B, C, D: PIBTime): PIBTime; cdecl; export;
begin
  if CompInt64(TimeToSec(A^), Op, TimeToSec(B^)) then
    Result := C
  else
    Result := D;
end;

exports
  IF_SS,
  IF_SN,
  IF_ST,

  IF_NS,
  IF_NN,
  IF_NT,

  IF_TS,
  IF_TN,
  IF_TT;

begin
end.
